; Marijus Merkevicius
; 17. Paraykite program, kuri vest atuntain skaii urao deimtainiu pavidalu.
; Laikoma, kad skaiiai (deintainiu pavidalu) yra nuo 0 iki 65535;
.model small
.stack 100h
.data
	;zinutes vartotojui
	welcome_message db "Iveskite 8taini skaiciu", 10, 13, "$"
	result_message db "Skaicius desimtainiu formatu ", 10, 13, "$"
	error_message db "Ivestas simbolis nepriklausantis 8tainei sistemai", 10, 13, "$"
	help_message db "Programa 8taini skaiciu pavercia i 10taini", 10, 13, "$"
	neivesta db "Nieko neivesta", 10, 13, "$"
	per_didelis_skaicius db "Ivestas skaicius yra per didelis.", 10, 13, "$"
	new_line db 10, 13, "$"
	
	buffer db 255, ?, 256 dup (0) ; nuskaitomos eilutes buferis
	
	; papildomi kintamieji
	kiekis db 0
	atsakymas dw 0
.code
start:
	; nurodome duomenu segmento vieta
	mov ax, @data
	mov ds, ax
	
	MOV BX, 81h ; i BX ikeliam 81h reiksme, nes programos parametrai saugomi adresu ES:0081h
	
tikrinimas:
	mov ax, es:[bx] ; nuskaitom pirmus du parametro baitus
	inc bx ; per sekanti skaitima imsim vienu baitu daugiau.
	
	cmp al, 13 ; tikriname ar simbolis nera enter
	je pradzia ; jei taip tada sokam toliau
	cmp al, 20h ; jei simbolis tarpas
	je tikrinimas ; tai tikrinam sekanti simboli
	cmp ax, "?/" ; jei ne tarpas ir ne enter, tikriname ax su "?/".
	jne pradzia ; jei ivestas ne tarpas, ne enter ir ne "/?" tada ignoruojame
	mov ax, es:[bx] ; nuskaitom per viena baita toliau, nes BX po praejusio nuskaitymo buvo padidintas 1
	cmp ah, 13 ; patikrinam ar po to kai ivestas "/?" buvo paspaustas enter
	je help ; jei taip, isvedam help pranesima
	jmp pradzia ; jei ne tai programa vykdoma toliau
	
help:
	
	; ispausdinamas help pranesimas
	mov dx, offset help_message;
	mov ah, 09h
	int 21h
	
	; uzbaigiame programa
	jmp pabaiga
	
pradzia:
	; prasome vartotojo ivesti skaiciu
	mov dx, offset welcome_message
	mov ah, 09h
	int 21h
	
	; nuskaitomas bufferis
	mov dx, offset buffer
	mov ah, 0Ah
	int 21h
	
	; kursorius perkeliamas i naujos eilutes pradzia
	mov ah, 09h
	mov dx, offset new_line
	int 21h
	
	
	mov si, offset buffer ; i source indexa ikeliamas bufferio pradzios adresas
	inc si 
	mov cl, [ds:si] ; si padidinamas vienetu ir nuskaitomas antras bufferio baitas - nuskaitytu simboliu kiekis
	mov kiekis, cl ; nusikopijuojame cl reiksme nes ja reikes panaudoti dar kelis kartus
	
	; jei neivestas nei vienas simbolis, programa baigia darba
	cmp cl, 0
	je nieko_neivesta
	
kelimas_i_stacka:
	; konvertuojame visus ascii simbolius i desimtainius
	; ir sudedame juos i stacka
	
	; i al ikeliame sekanti simboli
	inc si
	mov al, [ds:si] 
	
	; tikriname ar simbolis yra is 8taines sistemos
	cmp al, 48
	jb klaida
	cmp al, 55
	ja klaida
	
	; konvertuojame is ascii kodo
	sub al, 48
	
	; ikeliame simboli i stacka
	push ax
	
	loop kelimas_i_stacka
	
toliau:
	
	mov cl, kiekis ; nustatome cl reiksme sekanciam ciklui
	
	; bx bus naudojamas dauginant skaitmenis
	; bx = 1 = 8^0, veliau jis bus keliamas didesniu laipsniu
	mov bx, 1
	xor dx,dx
	
vertimas:
	; kiekvienas simbolis yra padauginamas is astuoneto su atitinkamu laipsniu
	; ir sandaugos produktas pridedamas prie atsakymo.

	pop ax ; is stacko paimamas simbolis
	xor ah, ah ; nunulinamas ah
	
	mul bx ; ax = al * bx
	add atsakymas, ax ; prie atsakymo pridedama reiksme
	add dx, ax
	jc per_didelis
	
	; bx perkeliamas i ax, padauginamas is 8
	; ir vel perkeliamas i bx, sekanciui kartui
	mov ax, bx
	mov bx, 8
	mul bx
	mov bx, ax

	loop vertimas
	
	mov cl, kiekis ; grazinama cl reiksme
	
	
spausdinimas:
	; nukerpame po viena skaiciaus simboli ir dedame ji i stacka
	; veliau imsime is stacko ir versime i ascii koda
	
	; nukerpamas paskutinis simbolis
	mov dx, 0
	mov ax, atsakymas
	mov bx, 10
	div bx ;dx = liekana, ax = dalmuo
	
	; likes skaicius perkeliamas atgal i atsakyma
	mov atsakymas, ax

	; nukirptas skaitmuo keliamas i stacka
	push dx
	
	loop spausdinimas
	
	mov cl, kiekis ; atstatoma cl reiksme
	jmp perejimas
	
perejimas:
	; tikriname ar pirmas skaitmuo nulis, jei taip
	; tai jo nespausdiname
	pop ax
	cmp al, 0
	je nulis
	
	; jei ne nulis sugraziname reiksme i stacka ir tesiame toliau
	push ax
	jmp spausdinimas_toliau
	
nulis:
	; jei nulis cl pamaziname vienetu ir tesiam toliau
	dec cl
	jmp spausdinimas_toliau
	
spausdinimas_toliau:
	; is stacko isimame po viena simboli, 
	; ji verciame i ascii koda ir spausdiname
	
	pop ax ; isimamas simbolis is stacko
	add al, 48 ; paverciamas i ascii koda
	
	; spausdinamas simbolis
	mov ah, 02h
	mov dl, al
	int 21h
	
	loop spausdinimas_toliau
	
	jmp pabaiga
	
klaida:

	mov dx, offset error_message
	mov ah, 09h
	int 21h
	
	jmp pabaiga
	
nieko_neivesta:
	
	mov dx, offset neivesta
	mov ah, 09h
	int 21h
	
	jmp pabaiga
	
per_didelis:
	
	mov dx, offset per_didelis_skaicius
	mov ah, 09h	
	int 21h
	
	jmp pabaiga
	
pabaiga:
	; uzbaigiame programa
	
	mov ah, 4ch
	int 21h; nieko neivesta, db, @ data, >2B, 4ch

end start